<?php
/**
 * @file
 * Node revision translation handler for the State Flow module.
 */

/**
 * State Flow translation handler.
 *
 * Overrides Node behaviors for State Flow revision.
 *
 * @see state_flow_entity_info_alter().
 */
class EntityTranslationStateFlowHandler extends EntityTranslationNodeHandler {

  /**
   * @see EntityTranslationHandlerInterface::getCurrentEntityRevision()
   */
  public function getCurrentEntityRevision() {
    // If we're in the path scheme state_flow_entity a dedicated revision is
    // edited thus don't overwrite it with the current one.
    $this->initPathScheme();
    if (!$this->isNewEntity() && $this->getPathScheme() == 'state_flow') {
      return $this->entity;
    }
    return parent::getCurrentEntityRevision();
  }

}